diff --git a/src/zabbix_server/poller/poller.c b/src/zabbix_server/poller/poller.c
index 0fe160b..f94c177 100644
--- a/src/zabbix_server/poller/poller.c
+++ b/src/zabbix_server/poller/poller.c
@@ -48,211 +48,21 @@
 extern unsigned char	process_type, program_type;
 extern int		server_num, process_num;
 
-/******************************************************************************
- *                                                                            *
- * Function: db_host_update_availability                                      *
- *                                                                            *
- * Purpose: write host availability changes into database                     *
- *                                                                            *
- * Parameters: ha    - [IN] the host availability data                        *
- *                                                                            *
- * Return value: SUCCEED - the availability changes were written into db      *
- *               FAIL    - no changes in availability data were detected      *
- *                                                                            *
- ******************************************************************************/
-static int	db_host_update_availability(const zbx_host_availability_t *ha)
-{
-	char	*sql = NULL;
-	size_t	sql_alloc = 0, sql_offset = 0;
-
-	if (SUCCEED == zbx_sql_add_host_availability(&sql, &sql_alloc, &sql_offset, ha))
-	{
-		DBbegin();
-		DBexecute("%s", sql);
-		DBcommit();
-
-		zbx_free(sql);
-
-		return SUCCEED;
-	}
-
-	return FAIL;
-}
-
-/******************************************************************************
- *                                                                            *
- * Function: host_get_availability                                            *
- *                                                                            *
- * Purpose: get host availability data based on the specified agent type      *
- *                                                                            *
- * Parameters: dc_host      - [IN] the host                                   *
- *             type         - [IN] the agent type                             *
- *             availability - [OUT] the host availability data                *
- *                                                                            *
- * Return value: SUCCEED - the host availability data was retrieved           *
- *                         successfully                                       *
- *               FAIL    - failed to retrieve host availability data,         *
- *                         invalid agent type was specified                   *
- *                                                                            *
- ******************************************************************************/
-static int	host_get_availability(const DC_HOST *dc_host, unsigned char agent, zbx_host_availability_t *ha)
-{
-	zbx_agent_availability_t	*availability = &ha->agents[agent];
-
-	availability->flags = ZBX_FLAGS_AGENT_STATUS;
-
-	switch (agent)
-	{
-		case ZBX_AGENT_ZABBIX:
-			availability->available = dc_host->available;
-			availability->error = zbx_strdup(NULL, dc_host->error);
-			availability->errors_from = dc_host->errors_from;
-			availability->disable_until = dc_host->disable_until;
-			break;
-		case ZBX_AGENT_SNMP:
-			availability->available = dc_host->snmp_available;
-			availability->error = zbx_strdup(NULL, dc_host->snmp_error);
-			availability->errors_from = dc_host->snmp_errors_from;
-			availability->disable_until = dc_host->snmp_disable_until;
-			break;
-		case ZBX_AGENT_IPMI:
-			availability->available = dc_host->ipmi_available;
-			availability->error = zbx_strdup(NULL, dc_host->ipmi_error);
-			availability->errors_from = dc_host->ipmi_errors_from;
-			availability->disable_until = dc_host->ipmi_disable_until;
-			break;
-		case ZBX_AGENT_JMX:
-			availability->available = dc_host->jmx_available;
-			availability->error = zbx_strdup(NULL, dc_host->jmx_error);
-			availability->disable_until = dc_host->jmx_disable_until;
-			availability->errors_from = dc_host->jmx_errors_from;
-			break;
-		default:
-			return FAIL;
-	}
-
-	ha->hostid = dc_host->hostid;
-
-	return SUCCEED;
-}
-
-/******************************************************************************
- *                                                                            *
- * Function: host_set_availability                                            *
- *                                                                            *
- * Purpose: sets host availability data based on the specified agent type     *
- *                                                                            *
- * Parameters: dc_host      - [IN] the host                                   *
- *             type         - [IN] the agent type                             *
- *             availability - [IN] the host availability data                 *
- *                                                                            *
- * Return value: SUCCEED - the host availability data was set successfully    *
- *               FAIL    - failed to set host availability data,              *
- *                         invalid agent type was specified                   *
- *                                                                            *
- ******************************************************************************/
-static int	host_set_availability(DC_HOST *dc_host, unsigned char agent, const zbx_host_availability_t *ha)
-{
-	const zbx_agent_availability_t	*availability = &ha->agents[agent];
-	unsigned char			*pavailable;
-	int				*perrors_from, *pdisable_until;
-	char				*perror;
-
-	switch (agent)
-	{
-		case ZBX_AGENT_ZABBIX:
-			pavailable = &dc_host->available;
-			perror = dc_host->error;
-			perrors_from = &dc_host->errors_from;
-			pdisable_until = &dc_host->disable_until;
-			break;
-		case ZBX_AGENT_SNMP:
-			pavailable = &dc_host->snmp_available;
-			perror = dc_host->snmp_error;
-			perrors_from = &dc_host->snmp_errors_from;
-			pdisable_until = &dc_host->snmp_disable_until;
-			break;
-		case ZBX_AGENT_IPMI:
-			pavailable = &dc_host->ipmi_available;
-			perror = dc_host->ipmi_error;
-			perrors_from = &dc_host->ipmi_errors_from;
-			pdisable_until = &dc_host->ipmi_disable_until;
-			break;
-		case ZBX_AGENT_JMX:
-			pavailable = &dc_host->jmx_available;
-			perror = dc_host->jmx_error;
-			pdisable_until = &dc_host->jmx_disable_until;
-			perrors_from = &dc_host->jmx_errors_from;
-			break;
-		default:
-			return FAIL;
-	}
-
-	if (0 != (availability->flags & ZBX_FLAGS_AGENT_STATUS_AVAILABLE))
-		*pavailable = availability->available;
-
-	if (0 != (availability->flags & ZBX_FLAGS_AGENT_STATUS_ERROR))
-		zbx_strlcpy(perror, availability->error, HOST_ERROR_LEN_MAX);
-
-	if (0 != (availability->flags & ZBX_FLAGS_AGENT_STATUS_ERRORS_FROM))
-		*perrors_from = availability->errors_from;
-
-	if (0 != (availability->flags & ZBX_FLAGS_AGENT_STATUS_DISABLE_UNTIL))
-		*pdisable_until = availability->disable_until;
-
-	return SUCCEED;
-}
-
-static unsigned char	host_availability_agent_by_item_type(unsigned char type)
-{
-	switch (type)
-	{
-		case ITEM_TYPE_ZABBIX:
-			return ZBX_AGENT_ZABBIX;
-			break;
-		case ITEM_TYPE_SNMPv1:
-		case ITEM_TYPE_SNMPv2c:
-		case ITEM_TYPE_SNMPv3:
-			return ZBX_AGENT_SNMP;
-			break;
-		case ITEM_TYPE_IPMI:
-			return ZBX_AGENT_IPMI;
-			break;
-		case ITEM_TYPE_JMX:
-			return ZBX_AGENT_JMX;
-			break;
-		default:
-			return ZBX_AGENT_UNKNOWN;
-	}
-}
-
-void	zbx_activate_item_host(DC_ITEM *item, zbx_timespec_t *ts)
+void	zbx_activate_item_host(DC_ITEM *item)
 {
 	const char		*__function_name = "zbx_activate_item_host";
-	zbx_host_availability_t	in, out;
-	unsigned char		agent_type;
+	unsigned int		flags;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() hostid:" ZBX_FS_UI64 " itemid:" ZBX_FS_UI64 " type:%d",
 			__function_name, item->host.hostid, item->itemid, (int)item->type);
 
-	zbx_host_availability_init(&in, item->host.hostid);
-	zbx_host_availability_init(&out, item->host.hostid);
-
-	if (ZBX_AGENT_UNKNOWN == (agent_type = host_availability_agent_by_item_type(item->type)))
-		goto out;
-
-	if (FAIL == host_get_availability(&item->host, agent_type, &in))
+	if (ZBX_AGENT_STATUS_NONE == (flags = zbx_dc_item_activate(item)))
 		goto out;
 
-	if (FAIL == DChost_activate(item->host.hostid, agent_type, ts, &in.agents[agent_type], &out.agents[agent_type]))
+	if (HOST_AVAILABLE_UNSET == item->agent.available || HOST_AVAILABLE_UNKNOWN == item->agent.available)
 		goto out;
 
-	if (FAIL == db_host_update_availability(&out))
-		goto out;
-
-	host_set_availability(&item->host, agent_type, &out);
-
-	if (HOST_AVAILABLE_TRUE == in.agents[agent_type].available)
+	if (0 == (flags & ZBX_AGENT_STATUS_AVAILABLE))
 	{
 		zabbix_log(LOG_LEVEL_WARNING, "resuming %s checks on host \"%s\": connection restored",
 				zbx_agent_type_string(item->type), item->host.host);
@@ -263,58 +73,40 @@ void	zbx_activate_item_host(DC_ITEM *item, zbx_timespec_t *ts)
 				zbx_agent_type_string(item->type), item->host.host);
 	}
 out:
-	zbx_host_availability_clean(&out);
-	zbx_host_availability_clean(&in);
-
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __function_name);
 }
 
 void	zbx_deactivate_item_host(DC_ITEM *item, zbx_timespec_t *ts, const char *error)
 {
 	const char		*__function_name = "zbx_deactivate_item_host";
-	zbx_host_availability_t	in, out;
-	unsigned char		agent_type;
+	unsigned int		flags;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() hostid:" ZBX_FS_UI64 " itemid:" ZBX_FS_UI64 " type:%d",
 			__function_name, item->host.hostid, item->itemid, (int)item->type);
 
-	zbx_host_availability_init(&in, item->host.hostid);
-	zbx_host_availability_init(&out,item->host.hostid);
-
-	if (ZBX_AGENT_UNKNOWN == (agent_type = host_availability_agent_by_item_type(item->type)))
+	if (ZBX_AGENT_STATUS_NONE == (flags = zbx_dc_item_deactivate(item, ts, error)))
 		goto out;
 
-	if (FAIL == host_get_availability(&item->host, agent_type, &in))
+	if (HOST_AVAILABLE_UNSET == item->agent.available || HOST_AVAILABLE_UNKNOWN == item->agent.available)
 		goto out;
 
-	if (FAIL == DChost_deactivate(item->host.hostid, agent_type, ts, &in.agents[agent_type],
-			&out.agents[agent_type], error))
-	{
-		goto out;
-	}
-
-	if (FAIL == db_host_update_availability(&out))
-		goto out;
-
-	host_set_availability(&item->host, agent_type, &out);
-
-	if (0 == in.agents[agent_type].errors_from)
+	if (0 != (flags & ZBX_AGENT_STATUS_ERRORS_FROM))
 	{
 		zabbix_log(LOG_LEVEL_WARNING, "%s item \"%s\" on host \"%s\" failed:"
 				" first network error, wait for %d seconds",
 				zbx_agent_type_string(item->type), item->key_orig, item->host.host,
-				out.agents[agent_type].disable_until - ts->sec);
+				CONFIG_UNREACHABLE_DELAY);
 	}
 	else
 	{
-		if (HOST_AVAILABLE_FALSE != in.agents[agent_type].available)
+		if (HOST_AVAILABLE_FALSE != item->agent.available)
 		{
-			if (HOST_AVAILABLE_FALSE != out.agents[agent_type].available)
+			if (0 == (flags & ZBX_AGENT_STATUS_AVAILABLE))
 			{
 				zabbix_log(LOG_LEVEL_WARNING, "%s item \"%s\" on host \"%s\" failed:"
 						" another network error, wait for %d seconds",
 						zbx_agent_type_string(item->type), item->key_orig, item->host.host,
-						out.agents[agent_type].disable_until - ts->sec);
+						CONFIG_UNREACHABLE_DELAY);
 			}
 			else
 			{
@@ -324,13 +116,7 @@ void	zbx_deactivate_item_host(DC_ITEM *item, zbx_timespec_t *ts, const char *err
 			}
 		}
 	}
-
-	zabbix_log(LOG_LEVEL_DEBUG, "%s() errors_from:%d available:%d", __function_name,
-			out.agents[agent_type].errors_from, out.agents[agent_type].available);
 out:
-	zbx_host_availability_clean(&out);
-	zbx_host_availability_clean(&in);
-
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __function_name);
 }
 
@@ -746,7 +532,7 @@ static int	get_values(unsigned char poller_type, int *nextcheck)
 			case AGENT_ERROR:
 				if (HOST_AVAILABLE_TRUE != last_available)
 				{
-					zbx_activate_item_host(&items[i], &timespec);
+					zbx_activate_item_host(&items[i]);
 					last_available = HOST_AVAILABLE_TRUE;
 				}
 				break;
diff --git a/src/zabbix_server/poller/poller.h b/src/zabbix_server/poller/poller.h
index 08711ff..c1a6272 100644
--- a/src/zabbix_server/poller/poller.h
+++ b/src/zabbix_server/poller/poller.h
@@ -29,7 +29,7 @@ extern int	CONFIG_UNREACHABLE_DELAY;
 
 ZBX_THREAD_ENTRY(poller_thread, args);
 
-void	zbx_activate_item_host(DC_ITEM *item, zbx_timespec_t *ts);
+void	zbx_activate_item_host(DC_ITEM *item);
 void	zbx_deactivate_item_host(DC_ITEM *item, zbx_timespec_t *ts, const char *error);
 
 #endif
diff --git a/src/zabbix_server/server.c b/src/zabbix_server/server.c
index 593bb8b..b38c9f6 100644
--- a/src/zabbix_server/server.c
+++ b/src/zabbix_server/server.c
@@ -60,6 +60,7 @@
 #include "taskmanager/taskmanager.h"
 #include "preprocessor/preproc_manager.h"
 #include "preprocessor/preproc_worker.h"
+#include "availability/availability.h"
 #include "events.h"
 #include "../libs/zbxdbcache/valuecache.h"
 #include "setproctitle.h"
@@ -175,6 +176,7 @@ int	CONFIG_IPMIMANAGER_FORKS	= 0;
 int	CONFIG_ALERTMANAGER_FORKS	= 1;
 int	CONFIG_PREPROCMAN_FORKS		= 1;
 int	CONFIG_PREPROCESSOR_FORKS	= 3;
+int	CONFIG_AVAILABILITYSYNCER_FORKS	= 1;
 
 int	CONFIG_LISTEN_PORT		= ZBX_DEFAULT_SERVER_PORT;
 char	*CONFIG_LISTEN_IP		= NULL;
@@ -399,6 +401,11 @@ int	get_process_info_by_thread(int local_server_num, unsigned char *local_proces
 		*local_process_type = ZBX_PROCESS_TYPE_PREPROCESSOR;
 		*local_process_num = local_server_num - server_count + CONFIG_PREPROCESSOR_FORKS;
 	}
+	else if (local_server_num <= (server_count += CONFIG_AVAILABILITYSYNCER_FORKS))
+	{
+		*local_process_type = ZBX_PROCESS_TYPE_AVAILABILITY_SYNCER;
+		*local_process_num = local_server_num - server_count + CONFIG_AVAILABILITYSYNCER_FORKS;
+	}
 	else
 		return FAIL;
 
@@ -1050,7 +1057,8 @@ int	MAIN_ZABBIX_ENTRY(int flags)
 			+ CONFIG_ESCALATOR_FORKS + CONFIG_IPMIPOLLER_FORKS + CONFIG_JAVAPOLLER_FORKS
 			+ CONFIG_SNMPTRAPPER_FORKS + CONFIG_PROXYPOLLER_FORKS + CONFIG_SELFMON_FORKS
 			+ CONFIG_VMWARE_FORKS + CONFIG_TASKMANAGER_FORKS + CONFIG_IPMIMANAGER_FORKS
-			+ CONFIG_ALERTMANAGER_FORKS + CONFIG_PREPROCMAN_FORKS + CONFIG_PREPROCESSOR_FORKS;
+			+ CONFIG_ALERTMANAGER_FORKS + CONFIG_PREPROCMAN_FORKS + CONFIG_PREPROCESSOR_FORKS
+			+ CONFIG_AVAILABILITYSYNCER_FORKS;
 	threads = (pid_t *)zbx_calloc(threads, threads_num, sizeof(pid_t));
 
 	if (0 != CONFIG_TRAPPER_FORKS)
@@ -1161,6 +1169,9 @@ int	MAIN_ZABBIX_ENTRY(int flags)
 			case ZBX_PROCESS_TYPE_ALERTMANAGER:
 				threads[i] = zbx_thread_start(alert_manager_thread, &thread_args);
 				break;
+			case ZBX_PROCESS_TYPE_AVAILABILITY_SYNCER:
+				threads[i] = zbx_thread_start(availability_syncer_thread, &thread_args);
+				break;
 		}
 	}
 
diff --git a/src/zabbix_server/trapper/proxydata.c b/src/zabbix_server/trapper/proxydata.c
index 288da57..86f9280 100644
--- a/src/zabbix_server/trapper/proxydata.c
+++ b/src/zabbix_server/trapper/proxydata.c
@@ -174,8 +174,8 @@ void	zbx_send_proxy_data(zbx_socket_t *sock, zbx_timespec_t *ts)
 	struct zbx_json		j;
 	zbx_uint64_t		areg_lastid = 0, history_lastid = 0, discovery_lastid = 0;
 	char			*error = NULL;
-	int			availability_ts, more_history, more_discovery, more_areg;
-	zbx_vector_ptr_t	tasks;
+	int			more_history, more_discovery, more_areg;
+	zbx_vector_ptr_t	tasks, availability;
 	struct zbx_json_parse	jp, jp_tasks;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
@@ -186,10 +186,12 @@ void	zbx_send_proxy_data(zbx_socket_t *sock, zbx_timespec_t *ts)
 		goto out;
 	}
 
+	zbx_vector_ptr_create(&availability);
+
 	LOCK_PROXY_HISTORY;
 	zbx_json_init(&j, ZBX_JSON_STAT_BUF_LEN);
 
-	get_host_availability_data(&j, &availability_ts);
+	get_host_availability_data(&j, &availability);
 	proxy_get_hist_data(&j, &history_lastid, &more_history);
 	proxy_get_dhis_data(&j, &discovery_lastid, &more_discovery);
 	proxy_get_areg_data(&j, &areg_lastid, &more_areg);
@@ -212,8 +214,6 @@ void	zbx_send_proxy_data(zbx_socket_t *sock, zbx_timespec_t *ts)
 
 	if (SUCCEED == send_data_to_server(sock, j.buffer, &error))
 	{
-		zbx_set_availability_diff_ts(availability_ts);
-
 		DBbegin();
 
 		if (0 != history_lastid)
@@ -244,6 +244,8 @@ void	zbx_send_proxy_data(zbx_socket_t *sock, zbx_timespec_t *ts)
 	}
 	else
 	{
+		zbx_refresh_host_availability(&availability);
+
 		zabbix_log(LOG_LEVEL_WARNING, "cannot send proxy data to server at \"%s\": %s", sock->peer, error);
 		zbx_free(error);
 	}
@@ -251,6 +253,10 @@ void	zbx_send_proxy_data(zbx_socket_t *sock, zbx_timespec_t *ts)
 	zbx_vector_ptr_clear_ext(&tasks, (zbx_clean_func_t)zbx_tm_task_free);
 	zbx_vector_ptr_destroy(&tasks);
 
+	zbx_vector_ptr_clear_ext(&availability, zbx_agent_status_update_free);
+	zbx_vector_ptr_destroy(&availability);
+
+
 	zbx_json_free(&j);
 	UNLOCK_PROXY_HISTORY;
 out:
diff --git a/tests/libs/zbxhistory/Makefile.am b/tests/libs/zbxhistory/Makefile.am
index 47c6d4b..b1aa400 100644
--- a/tests/libs/zbxhistory/Makefile.am
+++ b/tests/libs/zbxhistory/Makefile.am
@@ -22,7 +22,6 @@ zbx_history_get_values_SOURCES = \
 zbx_history_get_values_WRAP = \
 	-Wl,--wrap=zbx_sleep_loop \
 	-Wl,--wrap=DCget_nextid \
-	-Wl,--wrap=zbx_host_availability_is_set \
 	-Wl,--wrap=zbx_add_event \
 	-Wl,--wrap=zbx_process_events \
 	-Wl,--wrap=zbx_clean_events
diff --git a/tests/libs/zbxhistory/zbx_history_get_values.c b/tests/libs/zbxhistory/zbx_history_get_values.c
index 0967b01..c0231fb 100644
--- a/tests/libs/zbxhistory/zbx_history_get_values.c
+++ b/tests/libs/zbxhistory/zbx_history_get_values.c
@@ -41,12 +41,6 @@ zbx_uint64_t	__wrap_DCget_nextid(const char *table_name, int num)
 	return 0;
 }
 
-int	__wrap_zbx_host_availability_is_set(const zbx_host_availability_t *ha)
-{
-	ZBX_UNUSED(ha);
-	return SUCCEED;
-}
-
 int	__wrap_zbx_add_event(unsigned char source, unsigned char object, zbx_uint64_t objectid,
 		const zbx_timespec_t *timespec, int value, const char *trigger_description,
 		const char *trigger_expression, const char *trigger_recovery_expression, unsigned char trigger_priority,
